var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { Fragment as _Fragment, jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Canvas, useFrame } from "@react-three/fiber";
import { forwardRef } from "react";
import store from "./store";
function ScissorRenderer() {
    var windows = store(function (s) { return s.windows; });
    var frameSubscribers = store(function (s) { return s.frameSubscribers; });
    var initSubscribers = store(function (s) { return s.initSubscribers; });
    var sethasInit = store(function (s) { return s.sethasInit; });
    useFrame(function (state) {
        var gl = state.gl;
        gl.setScissorTest(false);
        gl.clear(true, true);
        gl.setScissorTest(true);
        // const transform = `translateY(${window.scrollY}px)`;
        // if (gl.domElement.parentElement)
        //   gl.domElement.parentElement.style.transform = transform;
        for (var key in windows) {
            var _a = windows[key], scene = _a.scene, element = _a.element, camera = _a.camera, hasInit = _a.hasInit;
            if (scene && camera) {
                if (!hasInit) {
                    if (initSubscribers[key])
                        initSubscribers[key]({
                            scene: scene,
                            camera: camera,
                            element: element,
                        });
                    scene.add(camera);
                    sethasInit(true, key);
                }
                var rect = element.getBoundingClientRect();
                var left = rect.left, right = rect.right, top_1 = rect.top, bottom = rect.bottom, width = rect.width, height = rect.height;
                var isOffscreen = bottom < 0 ||
                    top_1 > gl.domElement.clientHeight ||
                    right < 0 ||
                    left > gl.domElement.clientWidth;
                if (!isOffscreen) {
                    var positiveYUpBottom = gl.domElement.clientHeight - bottom;
                    gl.setScissor(left, positiveYUpBottom, width, height);
                    gl.setViewport(left, positiveYUpBottom, width, height);
                    // @ts-ignore
                    camera.aspect = rect.width / rect.height;
                    // @ts-ignore
                    camera.updateProjectionMatrix();
                    if (frameSubscribers[key])
                        frameSubscribers[key]({
                            scene: scene,
                            camera: camera,
                            element: element,
                        });
                    gl.render(scene, camera);
                }
            }
        }
    }, 1);
    return _jsx(_Fragment, {}, void 0);
}
var ScissorCanvas = forwardRef(function (props, ref) {
    return (_jsxs(Canvas, __assign({ ref: ref, style: {
            position: "fixed",
            left: "0",
            top: "0",
            width: "100%",
            height: "100%",
            display: "block",
            zIndex: -1,
        } }, props, { children: [_jsx(ScissorRenderer, {}, void 0), props.children] }), void 0));
});
export default ScissorCanvas;
//# sourceMappingURL=ScissorCanvas.js.map