var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { forwardRef, useEffect, useRef } from "react";
import store from "./store";
import useCombinedRefs from "./hooks/useCombinedRefs";
var ScissorScene = forwardRef(function (_a, ref) {
    var uuid = _a.uuid, children = _a.children, rest = __rest(_a, ["uuid", "children"]);
    var addScene = store(function (s) { return s.addScene; });
    var removeScene = store(function (s) { return s.removeScene; });
    var localRef = useRef();
    var combinedRef = useCombinedRefs(ref, localRef);
    useEffect(function () {
        if (localRef.current) {
            addScene(localRef.current, uuid);
            return function () { return removeScene(uuid); };
        }
        else {
            return;
        }
    }, [localRef]);
    return (_jsx("scene", __assign({}, rest, { ref: combinedRef }, { children: children }), void 0));
});
export default ScissorScene;
//# sourceMappingURL=ScissorScene.js.map