import * as THREE from "three";
import { iScissorWindow, tScissorCallback } from "./ScissorTypes";
interface iScissorRootState {
    windows: {
        [key: string]: iScissorWindow;
    };
    frameSubscribers: {
        [key: string]: tScissorCallback;
    };
    initSubscribers: {
        [key: string]: tScissorCallback;
    };
    addWindow: (window: HTMLElement, id?: string | undefined) => string;
    removeWindow: (id: string) => any;
    addScene: (scene: THREE.Scene, id: string, camera?: THREE.Camera | undefined) => any;
    removeScene: (id: string) => any;
    sethasInit: (hasInit: boolean, id: string) => any;
    getIds: () => string[];
    addSubscriber: (cb: tScissorCallback, uuid: string[]) => any;
    removeSubscriber: (uuid: string[]) => any;
    addInitSubscriber: (cb: tScissorCallback, uuid: string[]) => any;
    removeInitSubscriber: (uuid: string[]) => any;
}
declare const _default: import("zustand").UseBoundStore<iScissorRootState, import("zustand").StoreApi<iScissorRootState>>;
export default _default;
